import * as React from 'react';
import { Redirect, RouteComponentProps, RouteProps, Route, Switch } from 'react-router-dom';
import { Container, Menu, Sidebar, Segment, Icon, Breadcrumb, Grid, Dropdown } from 'semantic-ui-react';
import { Header } from './Header';
import { Footer } from './Footer';
import TitleBarContainer from './TitleBarContainer';
import LeftMenu from './LeftMenu';

import TargetDetail from '../../views/infrastructure/target/Detail';
import SensorList from '../../views/monitoring/sensor/List';
import HistoryView from '../../views/history/List';

export interface Props extends RouteComponentProps<any> {
}
export interface State {
}

export class TargetDetailLayout extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
    };
  }


  public render(): JSX.Element {
    const sub = [
      {
        'name': 'Info',
        'path': '/',
      },
      {
        'name': 'Sensor',
        'path': '/sensor',
      },
      {
        'name': 'History',
        'path': '/history',
      },
    ];
    return (
      <Container fluid>
        <LeftMenu />
        <Segment basic style={{ margin: '0 0 0 210px', padding: '0' }}>
          <Header />
          <TitleBarContainer sub={sub} location={this.props.location.pathname} history={this.props.history}/>
          <Segment basic>
            <Switch>
              <Route exact={true} path={`${this.props.match.url}/:id`} component={TargetDetail} />
              <Route exact={true} path={`${this.props.match.url}/:id/sensor`} component={SensorList} />
              <Route exact={true} path={`${this.props.match.url}/:id/history`} component={HistoryView} />
            </Switch>
          </Segment>
          <Footer />
        </Segment>
      </Container >
    );
  }
}

export default TargetDetailLayout;

