import { connect, Dispatch } from 'react-redux';
import {
    TitleBar,
    StateProps as StateProps,
    DispatchProps as DispatchProps,
} from './TitleBar';

import { push as routerPush } from 'react-router-redux';

export function mapStateToProps(state: any, ownProps: any): StateProps {
    return {
        sub: ownProps.sub,
        location: ownProps.location,
        history: ownProps.history,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
    return {
        onRedirect: (path: string) => {
            dispatch(routerPush(path));
        },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(TitleBar);
