import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Probe from '@overflow/probe/api/model/Probe';
import History from '../../api/model/History';
import Page from '@overflow/commons/api/model/Page';
import * as ReadAllByProbeAndTypeActionTypes from '../action/read_all_by_probe_and_type';
import ReadAllByProbeAndTypeState, { defaultState as ReadAllByProbeAndTypeDefaultState } from '../state/ReadAllByProbeAndType';

const reducer: ReducersMapObject = {
  [ReadAllByProbeAndTypeActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllByProbeAndTypeState = ReadAllByProbeAndTypeDefaultState, action: Action<Page>):
    ReadAllByProbeAndTypeState => {
    return {
      ...state,
      historyPage: <Page>action.payload,
    };
  },
  [ReadAllByProbeAndTypeActionTypes.REQUEST_FAILURE]:
  (state: ReadAllByProbeAndTypeState = ReadAllByProbeAndTypeDefaultState, action: Action<Error>):
    ReadAllByProbeAndTypeState => {
    return state;
  },
};

export default reducer;
