import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Infra from '@overflow/infra/api/model/Infra';

import * as readActionType from '../action/read';
import ReadState, { defaultState as ReadDefaultState } from '../state/Read';

const reducer: ReducersMapObject = {
    [readActionType.REQUEST_SUCCESS]:
    (state: ReadState = ReadDefaultState, action: Action<Infra>):
        ReadState => {
        return {
            ...state,
            infra: <Infra>action.payload,
        };
    },
    [readActionType.REQUEST_FAILURE]:
    (state: ReadState = ReadDefaultState, action: Action<Error>):
        ReadState => {
        return state;
    },
};

export default reducer;
