
import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';

import * as HistoryTypeReadAllActions from '../action/history_type_read_all';
import HistoryTypeReadAllState, { defaultState as HistoryTypeReadAllDefaultState } from '../state/HistoryTypeReadAll';

import MetaHistoryType from '../../api/model/MetaHistoryType';

const reducer: ReducersMapObject = {
  [HistoryTypeReadAllActions.REQUEST_SUCCESS]:
  (state: HistoryTypeReadAllState = HistoryTypeReadAllDefaultState, action: Action<MetaHistoryType[]>):
   HistoryTypeReadAllState => {
    return {
      ...state,
      historyTypes: <MetaHistoryType[]>action.payload,
    };
  },
  [HistoryTypeReadAllActions.REQUEST_FAILURE]:
  (state: HistoryTypeReadAllState = HistoryTypeReadAllDefaultState, action: Action<Error>):
   HistoryTypeReadAllState => {
    return state;
  },
};

export default reducer;
