import { connect, Dispatch } from 'react-redux';
import {
    NotificationModal,
    StateProps as StateProps,
    DispatchProps as DispatchProps,
} from './components/Notification';
import { push as routerPush } from 'react-router-redux';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
import Member from '@overflow/member/api/model/Member';
import * as readAllUnconfirmedActions from '../redux/action/read_all_unconfirmed';
import PageParams from '@overflow/commons/api/model/PageParams';

export function mapStateToProps(state: any, props: any): StateProps {
    return {
        notifications: state.notifications,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
    return {
        onReadTop5Unconfirmed: (member: Member, pageParams: PageParams) => {
            dispatch(asyncRequestActions.request('NotificationService', 'readAllUnconfirmedByMember',
                                                 readAllUnconfirmedActions.REQUEST, JSON.stringify(member), JSON.stringify(pageParams)));
        },
        onRedirectAllNotifications: () => {
            dispatch(routerPush('/notifications/'));
        },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(NotificationModal);

