import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Page from '@overflow/commons/api/model/Page';

import * as ReadAllUnconfirmedActionTypes from '../action/read_all_unconfirmed';
import ReadAllUnconfirmedState, { defaultState as ReadAllUnconfirmedDefaultState } from '../state/ReadAllUnconfirmed';

const reducer: ReducersMapObject = {
  [ReadAllUnconfirmedActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllUnconfirmedState = ReadAllUnconfirmedDefaultState, action: Action<Page>):
  ReadAllUnconfirmedState => {
      return {
      ...state,
      notifications: <Page>action.payload,
    };
  },
  [ReadAllUnconfirmedActionTypes.REQUEST_FAILURE]:
  (state: ReadAllUnconfirmedState = ReadAllUnconfirmedDefaultState, action: Action<Error>):
  ReadAllUnconfirmedState => {
    return state;
  },
};

export default reducer;
