import { connect, Dispatch } from 'react-redux';
import {
  SensorConfigStepper,
  SensorConfigStepperStateProps,
  SensorConfigStepperDispatchProps,
} from './components/SensorConfigStepper';
// import State from '../redux/state/ReadAllByTarget';
import { push as routerPush } from 'react-router-redux';

import Target from '@overflow/target/api/model/Target';
import Sensor from '@overflow/sensor/api/model/Sensor';
import SensorItem from '@overflow/sensor/api/model/SensorItem';
import Domain from '@overflow/domain/api/model/Domain';
import MetaSensorItem from '@overflow/meta/api/model/MetaSensorItem';


import * as RegistSensorConfigActions from '../redux/action/regist_sensor_config';

import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
import * as targetListActions from '@overflow/target/redux/action/read_all_by_probe';
import * as readActionType from '@overflow/infra/redux/action/read';

// FIXME::....

export function mapStateToProps(state: any, props: any): SensorConfigStepperStateProps {
  return {
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): SensorConfigStepperDispatchProps {
  return {
    onRegistSensorConfig: (sensor: Sensor, sensorItemList: SensorItem[]) => {
        dispatch(asyncRequestActions.request('SensorService', 'registSensorConfig', RegistSensorConfigActions.REQUEST,
                                             JSON.stringify(sensor), JSON.stringify(sensorItemList)));
    },
    onMoveSensors: () => {
      dispatch(routerPush('/sensors'));
    },
    onMoveTargetSensors: (infraId: number) => {
      dispatch(routerPush('/target/' + String(infraId) + '/sensor'));
    },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(SensorConfigStepper);
