/**
 * Created by geek on 17. 7. 3.
 */

import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import SensorItem from '@overflow/sensor/api/model/SensorItem';
import Page from '@overflow/commons/api/model/Page';
import * as ItemReadAllBySensorActionTypes from '../action/item_read_all_by_sensor';
import ItemReadAllBySensorState, { defaultState as itemReadAllBySensorDefaultState } from '../state/ItemReadAllBySensor';

const reducer: ReducersMapObject = {
  [ItemReadAllBySensorActionTypes.REQUEST_SUCCESS]:
  (state: ItemReadAllBySensorState = itemReadAllBySensorDefaultState, action: Action<Page>): ItemReadAllBySensorState => {
    return {
      ...state,
      SensorItemList:<Page>action.payload,
    };
  },
  [ItemReadAllBySensorActionTypes.REQUEST_FAILURE]:
  (state: ItemReadAllBySensorState = itemReadAllBySensorDefaultState, action: Action<Error>): ItemReadAllBySensorState => {
    return state;
  },
};

export default reducer;
