

import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Sensor from '@overflow/sensor/api/model/Sensor';

import * as ReadAllByInfraActionTypes from '../action/read_all_by_infra';
import ReadAllByInfraState, { defaultState as readAllByInfraDefaultState } from '../state/ReadAllByInfra';
import Page from '@overflow/commons/api/model/Page';

const reducer: ReducersMapObject = {
  [ReadAllByInfraActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllByInfraState = readAllByInfraDefaultState, action: Action<Page>): ReadAllByInfraState => {
    return {
      ...state,
      SensorList:<Page>action.payload,
    };
  },
  [ReadAllByInfraActionTypes.REQUEST_FAILURE]:
  (state: ReadAllByInfraState = readAllByInfraDefaultState, action: Action<Error>):
  ReadAllByInfraState => {
    return state;
  },
};

export default reducer;
