

import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Sensor from '@overflow/sensor/api/model/Sensor';

import * as RegistSensorConfigActionTypes from '../action/regist_sensor_config';
import RegistSensorConfigState, { defaultState as RegistSensorConfigDefaultState } from '../state/RegistSensorConfig';

const reducer: ReducersMapObject = {
  [RegistSensorConfigActionTypes.REQUEST_SUCCESS]:
  (state: RegistSensorConfigState = RegistSensorConfigDefaultState, action: Action<boolean>): RegistSensorConfigState => {
    console.log(action);
    return {
      ...state,
      isSensorRegistSuccess:<boolean>action.payload,
    };
  },
  [RegistSensorConfigActionTypes.REQUEST_FAILURE]:
  (state: RegistSensorConfigState = RegistSensorConfigDefaultState, action: Action<Error>):
  RegistSensorConfigState => {
    return state;
  },
};

export default reducer;
